package xdoclet.maven;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.apache.maven.jelly.MavenJellyContext;
import org.apache.maven.project.Project;

public class Util  {

   static final String PLUGIN_ID = "maven-xdoclet-plugin";

   public Util() {
   }

   /**
    * Get a Map with all context props having name starting with prefix.
    * Plugin props get overidden by project props. (Maybe it's overkill ....)
    */
   public static Map getCascadedVars(Project aProject, String prefix) {
      HashMap vars = new HashMap();
      MavenJellyContext ctx = aProject.getPluginContext(PLUGIN_ID);
      Iterator iter = ctx.getVariableNames();
      while (iter.hasNext()) {
         String vname = (String) iter.next();
         if (vname == null) continue;
         if (!vname.startsWith(prefix)) continue;
         vars.put(vname, ctx.getVariable(vname));
      }
      ctx = aProject.getContext();
      iter = ctx.getVariableNames();
      while (iter.hasNext()) {
         String vname = (String) iter.next();
         if (vname == null) continue;
         if (!vname.startsWith(prefix)) continue;
         vars.put(vname, ctx.getVariable(vname));
      }
      return vars;
   }

}